#import "Controller.h"

@implementation Controller
- (void)updateInterface:(int)sides {
	if (sides > shape.maximumNumberOfSides) {
		increaseButton.enabled = NO;
		decreaseButton.enabled = YES;
		return;
	}
	
	if (sides < shape.minimumNumberOfSides) {
		increaseButton.enabled = YES;
		decreaseButton.enabled = NO;
		return;
	}
	
	if (!increaseButton.enabled)
		increaseButton.enabled = YES;
	if (!decreaseButton.enabled)
		decreaseButton.enabled = YES;
	
	numberOfSidesLabel.text = [NSString stringWithFormat:@"%d", shape.numberOfSides];
}

- (IBAction)decrease {
	int sides = shape.numberOfSides - 1;
	[shape setNumberOfSides:sides];
	[self updateInterface:sides];
}

- (IBAction)increase {
	int sides = shape.numberOfSides + 1;
	[shape setNumberOfSides:sides];
	[self updateInterface:sides];
}

- (void)awakeFromNib {
	[shape setMaximumNumberOfSides:12];
	[shape setNumberOfSides:numberOfSidesLabel.text.integerValue];
	[shape setMinimumNumberOfSides:3];
	NSLog(@"Controller awakeFromNib: %@", shape.name);
}

@end
